<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/IR.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/IR.py</title>
<link href="../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/IR.py</b><pre class="sxr"><a id="line1"></a><span class="lineno"> 1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno"> 2</span><span class="line"><span class="py-comment"># Copyright (C) 2007 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno"> 3</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line4"></a><span class="lineno"> 4</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno"> 5</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno"> 6</span><span class="line"><span class="py-comment">#</span></span>
<a id="line7"></a><span class="lineno"> 7</span>
<a id="line8"></a><span class="lineno"> 8</span><span class="line"><span class="py-keyword">import</span> ASG</span>
<a id="line9"></a><span class="lineno"> 9</span><span class="line"><span class="py-keyword">import</span> SXR</span>
<a id="line10"></a><span class="lineno">10</span><span class="line"><span class="py-keyword">import</span> cPickle</span>
<a id="line11"></a><span class="lineno">11</span>
<a id="line12"></a><span class="lineno">12</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/IR/IR.html">IR</a>(object):</span>
<a id="line13"></a><span class="lineno">13</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Top-level Internal Representation. This is essentially a dictionary</span></span>
<a id="line14"></a><span class="lineno">14</span><span class="line"><span class="py-string">    of different representations such as Parse Tree, Abstract Semantic Graph, etc.</span></span>
<a id="line15"></a><span class="lineno">15</span><span class="line"><span class="py-string">    &quot;&quot;&quot;</span></span>
<a id="line16"></a><span class="lineno">16</span>
<a id="line17"></a><span class="lineno">17</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/IR/IR.html#__init__">__init__</a>(self, files=None, asg=None, sxr=None):</span>
<a id="line18"></a><span class="lineno">18</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Constructor&quot;&quot;&quot;</span></span>
<a id="line19"></a><span class="lineno">19</span>
<a id="line20"></a><span class="lineno">20</span><span class="line">        self.files = files <span class="py-keyword">or</span> {}</span>
<a id="line21"></a><span class="lineno">21</span><span class="line">        <span class="py-string">&quot;&quot;&quot;A dictionary mapping filenames to `SourceFile.SourceFile` instances.&quot;&quot;&quot;</span></span>
<a id="line22"></a><span class="lineno">22</span><span class="line">        self.asg = asg <span class="py-keyword">or</span> ASG.ASG()</span>
<a id="line23"></a><span class="lineno">23</span><span class="line">        <span class="py-string">&quot;&quot;&quot;The Abstract Semantic Graph.&quot;&quot;&quot;</span></span>
<a id="line24"></a><span class="lineno">24</span><span class="line">        self.sxr = sxr <span class="py-keyword">or</span> SXR.SXR()</span>
<a id="line25"></a><span class="lineno">25</span><span class="line">        <span class="py-string">&quot;&quot;&quot;The Source Cross-Reference SymbolTable.&quot;&quot;&quot;</span></span>
<a id="line26"></a><span class="lineno">26</span>
<a id="line27"></a><span class="lineno">27</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/IR/IR.html#copy">copy</a>(self):</span>
<a id="line28"></a><span class="lineno">28</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Make a shallow copy of this IR.&quot;&quot;&quot;</span></span>
<a id="line29"></a><span class="lineno">29</span>
<a id="line30"></a><span class="lineno">30</span><span class="line">        <span class="py-keyword">return</span> type(self)(self.files.copy(),</span>
<a id="line31"></a><span class="lineno">31</span><span class="line">                          self.asg.copy(),</span>
<a id="line32"></a><span class="lineno">32</span><span class="line">                          self.sxr)</span>
<a id="line33"></a><span class="lineno">33</span>
<a id="line34"></a><span class="lineno">34</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/IR/IR.html#save">save</a>(self, filename):</span>
<a id="line35"></a><span class="lineno">35</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Saves an IR object to the given filename&quot;&quot;&quot;</span></span>
<a id="line36"></a><span class="lineno">36</span>
<a id="line37"></a><span class="lineno">37</span><span class="line">        file = open(filename, <span class="py-string">'wb'</span>)</span>
<a id="line38"></a><span class="lineno">38</span><span class="line">        pickler = cPickle.Pickler(file, 1)</span>
<a id="line39"></a><span class="lineno">39</span><span class="line">        pickler.dump(self)</span>
<a id="line40"></a><span class="lineno">40</span><span class="line">        file.close()</span>
<a id="line41"></a><span class="lineno">41</span>
<a id="line42"></a><span class="lineno">42</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/IR/IR.html#merge">merge</a>(self, other):</span>
<a id="line43"></a><span class="lineno">43</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Merges another IR. Files and declarations are appended to those in</span></span>
<a id="line44"></a><span class="lineno">44</span><span class="line"><span class="py-string">        this IR, and types are merged by overwriting existing types -</span></span>
<a id="line45"></a><span class="lineno">45</span><span class="line"><span class="py-string">        Unduplicator is responsible for sorting out the mess this may cause :)&quot;&quot;&quot;</span></span>
<a id="line46"></a><span class="lineno">46</span>
<a id="line47"></a><span class="lineno">47</span><span class="line">        <span class="py-comment">#merge files</span></span>
<a id="line48"></a><span class="lineno">48</span><span class="line">        replacement = {}</span>
<a id="line49"></a><span class="lineno">49</span><span class="line">        <span class="py-keyword">for</span> filename, file <span class="py-keyword">in</span> other.files.iteritems():</span>
<a id="line50"></a><span class="lineno">50</span><span class="line">            <span class="py-keyword">if</span> <span class="py-keyword">not</span> self.files.has_key(filename):</span>
<a id="line51"></a><span class="lineno">51</span><span class="line">                self.files[filename] = file</span>
<a id="line52"></a><span class="lineno">52</span><span class="line">                <span class="py-keyword">continue</span></span>
<a id="line53"></a><span class="lineno">53</span><span class="line">            myfile = self.files[filename]</span>
<a id="line54"></a><span class="lineno">54</span><span class="line">            replacement[file] = myfile</span>
<a id="line55"></a><span class="lineno">55</span><span class="line">            <span class="py-comment"># the 'main' flag dominates...</span></span>
<a id="line56"></a><span class="lineno">56</span><span class="line">            <span class="py-keyword">if</span> <span class="py-keyword">not</span> myfile.annotations[<span class="py-string">'primary'</span>]:</span>
<a id="line57"></a><span class="lineno">57</span><span class="line">                myfile.annotations[<span class="py-string">'primary'</span>] = file.annotations[<span class="py-string">'primary'</span>]</span>
<a id="line58"></a><span class="lineno">58</span><span class="line">            myfile.declarations.extend(file.declarations)</span>
<a id="line59"></a><span class="lineno">59</span><span class="line">            myfile.includes.extend(file.includes)</span>
<a id="line60"></a><span class="lineno">60</span><span class="line">        <span class="py-comment"># fix dangling inclusions of 'old' files</span></span>
<a id="line61"></a><span class="lineno">61</span><span class="line">        <span class="py-keyword">for</span> r <span class="py-keyword">in</span> replacement:</span>
<a id="line62"></a><span class="lineno">62</span><span class="line">            <span class="py-keyword">for</span> f <span class="py-keyword">in</span> self.files.values():</span>
<a id="line63"></a><span class="lineno">63</span><span class="line">                <span class="py-keyword">for</span> i <span class="py-keyword">in</span> f.includes:</span>
<a id="line64"></a><span class="lineno">64</span><span class="line">                    <span class="py-keyword">if</span> i.target == r:</span>
<a id="line65"></a><span class="lineno">65</span><span class="line">                        i.target = replacement[r]</span>
<a id="line66"></a><span class="lineno">66</span>
<a id="line67"></a><span class="lineno">67</span><span class="line">        <span class="py-comment"># merge ASG</span></span>
<a id="line68"></a><span class="lineno">68</span><span class="line">        self.asg.merge(other.asg)</span>
<a id="line69"></a><span class="lineno">69</span>
<a id="line70"></a><span class="lineno">70</span><span class="line">        <span class="py-comment"># merge SXR</span></span>
<a id="line71"></a><span class="lineno">71</span><span class="line">        self.sxr.merge(other.sxr)</span>
<a id="line72"></a><span class="lineno">72</span>
<a id="line73"></a><span class="lineno">73</span>
<a id="line74"></a><span class="lineno">74</span><span class="line"><span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/IR.html#load">load</a>(filename):</span>
<a id="line75"></a><span class="lineno">75</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Loads an IR object from the given filename&quot;&quot;&quot;</span></span>
<a id="line76"></a><span class="lineno">76</span>
<a id="line77"></a><span class="lineno">77</span><span class="line">    file = open(filename, <span class="py-string">'rb'</span>)</span>
<a id="line78"></a><span class="lineno">78</span><span class="line">    unpickler = cPickle.Unpickler(file)</span>
<a id="line79"></a><span class="lineno">79</span><span class="line">    ir = unpickler.load()</span>
<a id="line80"></a><span class="lineno">80</span><span class="line">    file.close()</span>
<a id="line81"></a><span class="lineno">81</span><span class="line">    <span class="py-keyword">return</span> ir</span>
<a id="line82"></a><span class="lineno">82</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:15 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
